include masm32rt.inc
include \masm32\macros\ucmacros.asm
.686p
.mmx
.xmm

RAWINPUTDEVICE struct
    usUsagePage USHORT  ?
    usUsage     USHORT  ?
    dwFlags     DWORD   ?
    hwndTarget  HWND    ?
RAWINPUTDEVICE ends

RAWINPUTHEADER  struct 
    dwType  DWORD   ?
    dwSize  DWORD   ?
    hDevice HANDLE  ?
    wParam  WPARAM  ?
RAWINPUTHEADER  ends
PRAWINPUTHEADER typedef ptr RAWINPUTHEADER

RAWMOUSE struct 
    usFlags WORD    ?
    union
        ulButtons   DWORD   ?
        struct
            usButtonFlags   WORD    ?
            usButtonData    WORD    ?
        ends
    ends
    ulRawButtons        DWORD   ?
    lLastX              SDWORD  ?
    lLastY              SDWORD  ?
    ulExtraInformation  DWORD   ?
RAWMOUSE ends
PRAWMOUSE typedef ptr RAWMOUSE

RAWKEYBOARD struct 
    MakeCode            WORD    ?
    Flags               WORD    ?
    Reserved            WORD    ?
    VKey                WORD    ?
    Message             DWORD   ?
    ExtraInformation    DWORD   ?
RAWKEYBOARD ends
PRAWKEYBOARD typedef ptr RAWKEYBOARD

RAWHID struct 
    dwSizeHid   DWORD ?
    dwCount     DWORD ?
    bRawData    BYTE 1 dup (?)
RAWHID ends
PRAWHID typedef ptr RAWHID

RAWINPUT struct 
    header  RAWINPUTHEADER  <>
    union data
        mouse       RAWMOUSE    <>
        keyboard    RAWKEYBOARD <>
        hid         RAWHID      <>
    ends
RAWINPUT ends
PRAWINPUT typedef ptr RAWINPUT

RawInputThread proto hWnd:HWND

.data?
    hInstance                   HINSTANCE   ?
    dwThreadID                  DWORD       ?
    hCloseevent                 HANDLE      ?
    hwnd                        HWND        ?
.code

WndProc proto hWnd:HWND,uMgs:UINT,wParam:WPARAM,lParam:LPARAM

main proc
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG

    mov hInstance,rv(GetModuleHandle,0)
    mov wc.hInstance,eax
    mov wc.cbSize,SIZEOF wc
    mov wc.style,CS_HREDRAW or CS_VREDRAW or CS_SAVEBITS
    mov wc.lpfnWndProc,OFFSET WndProc
    mov wc.cbClsExtra,0
    mov wc.cbWndExtra,0
    mov wc.hIcon,rv(LoadIcon,0,IDI_APPLICATION)
    mov wc.hIconSm,eax
    mov wc.hCursor,rv(LoadCursor,0,IDC_ARROW)
    mov wc.lpszMenuName,0
    mov wc.hbrBackground,rv(GetStockObject,WHITE_BRUSH);
    mov wc.lpszClassName,chr$("Win32Wnd")
    invoke RegisterClassEx,ADDR wc
    mov ebx,ASM(mov edi,rv(GetSystemMetrics,SM_CXSCREEN))
    mov esi,rv(GetSystemMetrics,SM_CYSCREEN)
    shr ebx,1
    shr eax,1
    shr edi,2
    shr esi,2
    mov esi,rv(CreateWindowEx,0,wc.lpszClassName,"Win32Wnd",WS_VISIBLE or WS_SYSMENU or WS_MAXIMIZEBOX or WS_MINIMIZEBOX or WS_SIZEBOX,edi,esi,ebx,eax,0,0,hInstance,0)
    mov hwnd,eax
    invoke UpdateWindow,esi 
    
    .while 1
        invoke GetMessage,ADDR msg,0,0,0
        .break .if !eax || eax == -1
        invoke TranslateMessage,ADDR msg
        invoke DispatchMessage,ADDR msg     
    .endw

    xor eax,eax 
    ret
    
main endp

WndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

    .if uMsg == WM_CLOSE
        invoke SetEvent,hCloseevent
        invoke PostQuitMessage,0
    .elseif uMsg == WM_CREATE       
        mov hCloseevent,rv(CreateEvent,0,1,0,0)     
        invoke CreateThread,0,0,OFFSET RawInputThread,hCloseevent,0,ADDR dwThreadID
    .else
        invoke DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    
    xor eax,eax
    ret
    
WndProc endp

RawInputThread proc hCloseEvent:HANDLE
LOCAL rid:RAWINPUTDEVICE
LOCAL hWndDummy:HWND
LOCAL cbSize:DWORD
LOCAL msg:MSG

    mov hWndDummy,rv(CreateWindowEx,0,"button",0,0,0,0,1,1,0,0,hInstance,0)

    mov rid.usUsagePage,1
    mov rid.usUsage,6
    mov rid.dwFlags,0
    m2m rid.hwndTarget,hWndDummy
    invoke RegisterRawInputDevices,ADDR rid,1,SIZEOF RAWINPUTDEVICE

    .while 1
        invoke MsgWaitForMultipleObjects,1,ADDR hCloseEvent,0,INFINITE,QS_RAWINPUT
        .if eax == WAIT_OBJECT_0+1
            .break .if rv(GetRawInputBuffer,0,ADDR cbSize,SIZEOF RAWINPUTHEADER)
            mov eax,cbSize
            imul eax,eax,16
            mov cbSize,eax
            .break .if !ASM(mov edi,alloc(cbSize))
            .while 1
                .if ASM( mov esi,rv(GetRawInputBuffer,edi,ADDR cbSize,SIZEOF RAWINPUTHEADER)) != -1 && eax
                    mov ebx,edi
                    push esi
                    .while esi
                        .if [edi].RAWINPUT.header.dwType == RIM_TYPEKEYBOARD
                            .if [edi].RAWINPUT.data.keyboard.VKey == VK_J   ; !!!  fix for wow64
                                fn MessageBox,hwnd,"sdfsdf",0,0
                            .endif
                        .endif
                        ; align 4 needed !
                        add edi,SIZEOF RAWINPUT + 3
                        and edi,-4
                        dec esi
                    .endw
                    pop esi
                .else
                    .break
                .endif
            .endw
            .while 1
                .break .if !rv(PeekMessage,ADDR msg,0,WM_INPUT,WM_INPUT,PM_REMOVE)
            .endw
            free edi            
        .else
            .break  
        .endif
    .endw
    invoke DestroyWindow,hWndDummy
    
    ret
    
RawInputThread endp
end main
